import java.util.ArrayList;


/**
 * The Class SemanticAnalysis.
 */
public class SemanticAnalysis {
	
	/**
	 * Actualiza variaveis indefinidas.
	 *
	 * @param functions the functions
	 * @param funcoesRetornadas the funcoes retornadas
	 */
	void actualizaVariaveisIndefinidas(ArrayList<StructFunction > functions, ArrayList<RetornFuncStruct > funcoesRetornadas)
	{
		//actualizar tipos de variaveis indefinidas
		  for(int i=0; i < functions.size(); i++)
		  {
			  if(functions.get(i).var_local.containsValue("Indefinido"))
			  {
			        Object[] keys = functions.get(i).var_local.keySet().toArray();
			        for(int g=0; g < keys.length; g++)
		      		if(functions.get(i).var_local.get((String) keys[g]).equals("Indefinido"))
		      		{
						//atribuir tipo da variavel = tipo de retorno da funcao invocada
						for(int f=0; f < funcoesRetornadas.size(); f++)
						{
							if(funcoesRetornadas.get(f).Variaveis.contains((String) keys[g]))
							{
								for(int v=0; v < functions.size(); v++)
								{
									if(functions.get(v).name.equals(funcoesRetornadas.get(f).nomeFuncao))
									{
										if(!functions.get(v).type_return.equals("void") )
										{
											functions.get(i).var_local.remove((String) keys[g]);
											functions.get(i).var_local.put((String) keys[g], functions.get(v).type_return);
										}
									}
								}
							}
						}
		      		}
			  }
		  }
	}
	
	/**
	 * Actualiza variaveis.
	 *
	 * @param functions the functions
	 * @param funcoesInv the funcoes inv
	 */
	void actualizaVariaveis(ArrayList<StructFunction > functions, ArrayList<InvokedFunctions> funcoesInv)
	{
		//actualizar tipos de variaveis registados nos argumentos das funcoes invocadas
		  for(int g=0; g < funcoesInv.size(); g++)
		  {
		    for(int s=0; s < funcoesInv.get(g).argumentos.size(); s++)
		    {
				if(funcoesInv.get(g).argumentos.get(s).tipo.equals("Indefinido"))
				{
					for(int i=0; i < functions.size(); i++)
					{
						if(functions.get(i).name.equals(funcoesInv.get(g).nomeF))
						{
							Object[] keys = functions.get(i).args.keySet().toArray();
							for(int j=0; j < keys.length; j++)
							{
								if(keys[j].equals(funcoesInv.get(g).argumentos.get(s).variavel))
								{
									funcoesInv.get(g).argumentos.get(s).tipo = functions.get(i).args.get(keys[j]);
								}
							}
						}
					}
				}
			}
		  }
	}
	
	/**
	 * Analise semantica1.
	 *
	 * @param ArrayList the functions
	 * @param ArrayList the funcoes invocadas
	 * @return true, if successful
	 */
	boolean analiseSemantica1(ArrayList<StructFunction > functions, ArrayList<String > funcoesInvocadas)
	{
		//analise semantica 1 - funcoes nao existentes
		  
	  	  boolean existe = false, error=false;
		  
		  for(int n=0; n < funcoesInvocadas.size(); n++)
		  {
			  for(int m = 0; m < functions.size(); m++)
			  {
			  	if(functions.get(m).name.equals(funcoesInvocadas.get(n)))
			  		existe=true;
			  }
		
			  if(!existe && funcoesInvocadas.size() != 0 )
			  {
				 System.out.println("A funcao "+ funcoesInvocadas.get(n) +" nao existe.");
				 error = true;
			  }
			  existe=false;
		  }
		  return error;
	}
	
	/**
	 * Analise semantica2.
	 *
	 * @param ArrayList the functions
	 * @param ArrayList the funcoes inv
	 * @param ArrayList the funcoes retornadas
	 * @return true, if successful
	 */
	boolean analiseSemantica2(ArrayList<StructFunction > functions, ArrayList<InvokedFunctions> funcoesInv, ArrayList<RetornFuncStruct > funcoesRetornadas)
	{
		//analise semantica 2 - verificacao de argumentos das funcoes invocadas
		boolean existeRetorno=false, error=false;
		for(int g=0; g < funcoesInv.size(); g++)
		{
			for(int d=0; d < functions.size(); d++)
			{
		  	  if(functions.get(d).name.equals(funcoesInv.get(g).nomeF))
			  {
					//verifica numero de argumentos
					if(functions.get(d).args.size() != funcoesInv.get(g).argumentos.size())
					{
					  System.out.println("Numero de argumentos usados na chamada a funcao " + funcoesInv.get(g).nomeF + " nao coincide com prototipo.");
					  error = true;
					}

					//verifica ordem e tipo dos argumentos
				    Object[] keys = functions.get(d).args.keySet().toArray();
				    for(int f=0; f < keys.length; f++)
				    {
						if(!functions.get(d).args.get(keys[f]).equals(funcoesInv.get(g).argumentos.get(f).tipo))
						{
							 System.out.print("Erro na chamada a funcao " + funcoesInv.get(g).nomeF + "!");
							 System.out.print(" O tipo esperado era: " + functions.get(d).args.get(keys[f]));
							 System.out.println(". O tipo utilizado foi: " + funcoesInv.get(g).argumentos.get(f).tipo);
							 error = true;
						}
					}
												  
					//verificar se existe alguma funcao cujo valor de retorno seja ignorado
					
				    if(!functions.get(d).type_return.equals("void") )
				    {
				      	for(int a=0; a < funcoesRetornadas.size(); a++)
				      	{
				      	  	if(funcoesRetornadas.get(a).nomeFuncaoActual.equals(funcoesInv.get(g).nomeFuncaoActual) &&
							   funcoesRetornadas.get(a).nomeFuncao.equals(funcoesInv.get(g).nomeF))
							existeRetorno=true;					
				      	}

				      	if(!existeRetorno)
						{
						  	System.out.println("Retorno da funcao " + funcoesInv.get(g).nomeF + " nao e' guardado!");
							error = true;
						}
				    }							
				}
			}
		}
		return error;
	}
	
	/**
	 * Analise semantica.
	 *
	 * @param ArrayList the functions
	 * @param ArrayList the funcoes retornadas
	 * @return true, if successful
	 */
	boolean analiseSemantica3(ArrayList<StructFunction > functions, ArrayList<RetornFuncStruct > funcoesRetornadas)
	{
		//analise semantica 3 - tipo de retorno de funcao igual a variavel atribuida
		boolean error=false;
		for(int y=0; y < funcoesRetornadas.size(); y++) //para cada funcao invocada
		{
		  	String n1="",n2="";
			for(int s=0; s < funcoesRetornadas.get(y).Variaveis.size(); s++) //para cada variavel dependente da funcao invocada
			{
			  for(int e=0; e < functions.size(); e++)
			  {
			      String invocada = funcoesRetornadas.get(y).nomeFuncao;
			      String analisada = funcoesRetornadas.get(y).nomeFuncaoActual;
			      String variavel = funcoesRetornadas.get(y).Variaveis.get(s);
		
				  if(functions.get(e).name.equals(analisada))
				  {				  	 
				  	  for(int f=0; f < functions.size(); f++)
				  	  {
						//analisar escopo local 
						if(functions.get(e).containsVar(variavel) && functions.get(f).name.equals(invocada))
						{
						    //analise de coincidencia de tipos retornados e das variaveis atribuidas
							if(!functions.get(e).getVarType(variavel).equals(functions.get(f).type_return))
							{
							  if(functions.get(f).type_return.equals("void"))
							  {
								  System.out.println("O retorno da funcao " + functions.get(f).name + " e' void.");
							  }
							  else
							  { 
								  System.out.println("Tipos de variaveis diferentes na funcao " + analisada +". O tipo de retorno da funcao " + functions.get(f).name +
								  " e': " +  functions.get(f).type_return +  " e o tipo da variavel " + variavel +" e': " +
								  functions.get(e).getVarType(variavel));
							  }
							  error=true;
							}
						}
						
						//avaliar se variavel de retorno � invocada com o tipo correcto de dados
						if(variavel.equals(functions.get(e).var_ret))
						{
							if(!functions.get(y).type_return.equals(functions.get(e).type_return))
							{
							    n1 = functions.get(y).name;
								n2 = functions.get(y).type_return;
							    error = true;
							}
						}
					 }
				  }  
			   }
			}

			if(!n1.equals(""))
			{
				 System.out.println("Retorno da funcao " + n1 + " e' " + n2 + "!");
									
			}
		}
		
		return error;
	}
	

}
